
classdef PIDController < handle
%Class definition for the PID controller that will be tried out for the
%first simulations
    properties
        Kp;
        Ti;
        Td;
        Ts;
        U; 
        e;
        f_e;
        e_sum;

    end
    methods
        function obj = PIDController(kp, ti, td, ts)
            obj.Kp = kp;
            obj.Ti = ti;
            obj.Td = td;
            obj.Ts = ts;
            obj.U=0; 
            obj.e=0;
            obj.f_e =0;
            obj.e_sum =0;


            %Implementing the filter using a moving average
        end

        function y = LowPassFilter(obj, u)
            Tf = obj.Ts*20;
            a = obj.Ts/(Tf + obj.Ts);
            y = (1-a)*obj.f_e + a*u;


        end

      
        function u = ControlSignal(obj, sp, y)
            new_e = sp - y;
            %new_e =  - y;
            f_new_e = LowPassFilter(obj, new_e); %Filtering of the new_e value
            de = (f_new_e - obj.f_e)/obj.Ts;
            obj.f_e = f_new_e;
           

            obj.e_sum = obj.e_sum + new_e*obj.Ts;
            u = obj.Kp*new_e + obj.Kp*obj.e_sum/obj.Ti + obj.Kp*obj.Td*de;
            obj.e = new_e;
            
            

%             obj.U = u + obj.Kp*(new_e - obj.e) + (obj.Kp/obj.Ti)*obj.Ts*(new_e) + (obj.Kp*obj.Td)*(new_e - obj.e)/obj.Ts;
%             u = obj.U;
%             obj.e = new_e;
        end
    end
end
