clc;
clear all;
clf;

%% Definition of parameters

N = 6000; 
parameters;
u=zeros(3,1); 

dt = 1;

sp = zeros(3,N);
sp_ship_vector = zeros(3,N);

sp(1,500:1000)=10;
sp(1,1500:2000)=10;
sp(1,2500:3000)=10;
sp(1,3500:4000)=10;
sp(1,4500:5000)=10;
sp(1,5500:6000)=10;

sp(2,1:500)=0;
sp(2,1000:1500)=10;
sp(2,2000:2500)=10;
sp(2,3000:3500)=10;
sp(2,4000:4500)=10;
sp(2,5000:5500)=10;

sp(3,1250:1750)=5;
sp(3,2250:2750)=5;
sp(3,3250:3750)=5;
sp(3,3250:3750)=5;
sp(3,4250:4750)=5;
sp(3,5250:5750)=5;

W_c = zeros(3,N);
W_v = zeros(3,N);
gamma = zeros(N);

xs =zeros(6,1);
x=xs;

model = BalchenModel(d,m,x,neu, A_F, A_L, L);

Y=zeros(3,N);
y_vector = zeros(3,N);
y_NED = zeros(3,N);
U=zeros(3,N); 

prompt = "Press 1 if you want to create System_ID with PID, 2 if you want to create System_ID using Linearized Model: ";
sys_id = input(prompt);



if sys_id==1
%     Kp1 = 800;
%     Ti1 = 100;
%     Td1 = 100;
%     
%     Kp2 = 1200;
%     Ti2 = 300;
%     Td2 = 400;
%     
%     Kp3 = 8000;
%     Ti3 = 1300;
%     Td3 = 200;

    Kp1 = 600;
    Ti1 = 200;
    Td1 = 150;
    
    Kp2 = 900;
    Ti2 = 550;
    Td2 = 300;
    
    Kp3 = 500000;
    Ti3 = 1500;
    Td3 = 350;

    surgeController = PIDController(Kp1,Ti1, Td1, dt);
    swayController = PIDController(Kp2,Ti2, Td2, dt);
    yawController = PIDController(Kp3,Ti3, Td3, dt);

    for i=1:N
        R = [cos(x(3)) -sin(x(3)) 0; sin(x(3)) cos(x(3)) 0; 0 0 1];
        %y_ship = model.ConvertFromNED(y_vector(:,i));
        y=eye(3,6)*x;
        y_vector(:,i) = y;
        y_NED(:,i) = R*y;
        sp_ship = R'*sp(:,i);
        sp_ship(3) = sp_ship(3)*pi/180;
        sp_ship_vector(:,i)=sp_ship;
    
        y1 = y(1);
        y2 = y(2);
        y3 = y(3);

        u(1) = surgeController.ControlSignal(sp_ship(1),y1);
        u(2) = swayController.ControlSignal(sp_ship(2),y2);
        u(3) = yawController.ControlSignal(sp_ship(3),y3);

        if abs(u(1)) > 200000
            u(1)= 200000*sign(u(1));
        end
        if abs(u(2)) > 200000
            u(2)= 200000*sign(u(2));
        end
        if abs(u(3)) > 200000
            u(3)= 200000*sign(u(3));
        end

        U(:,i)=u; 

        F_w(:,i) = model.WindForce(W_v(i),gamma(i), x(3), x(4), x(5), A_F, A_L, L);

        [x, NED_Position] = model.UpdateState(u(:), W_c(:,i), W_v(i), gamma(i), dt);
        
        X(:,i)=x; 
        Y(:,i)=y_NED(:,i);
    end

else
    [A, B, D] = linearize_model(u, d, m, dt);

    G=0.01*eye(6);
    Q_k = diag([0.09, 0.11, 0.09,0.8,0.5,1.5]);
    R_k = diag([1e3,1e3,1e3]);
    K=dlqe(A,G,D,Q_k,R_k);

    q = [1e4 0 0; 0 1e4 0; 0 0 1e6];
    p = [1e-3 0 0; 0 1e-6 0; 0 0 1e-10];
    [G1, G2, At, Bt, Dt, Rr]=dlqdu_pi(A,B,D,q,p);

    %% main control loop
    X=zeros(6,N);
    x_est = zeros(6,1);
    
    %R=zeros(3,N); 
     
    y_old = D*xs; 
    x_old=xs;
    
    for i=1:N
        y=eye(3,6)*x;
        
        %     y1 = x(1) + x(1)*0.01*(10-rand*(101-99)); 
        %     y2 = x(2) + x(2)*0.01*(10-rand*(101-99));
        %     y3 = x(3) + x(3)*0.01*(10-rand*(101-99));
        %     y=[y1; y2; y3];

        y_vector(:,i) = y;
        R = [cos(x(3)) -sin(x(3)) 0; sin(x(3)) cos(x(3)) 0; 0 0 1];
        y_NED(:,i) = R*y;
        sp_ship = R'*sp(:,i); % Convert the setpoint from NED to the ship's reference frame.
        sp_ship(3) = sp_ship(3)*pi/180;
        sp_ship_vector(:,i)=sp_ship;

        u = u + G1*(x_est-x_old) + G2*(y_old - sp_ship);

        %Clipping u
%         if abs(u(1)) > 2e5
%             u(1) = 2e5*sign(u(1));
%         end
%         if abs(u(2)) > 2e5
%             u(2) = 2e5*sign(u(2));
%         end
%         if abs(u(3)) > 1e6
%             u(3) = 1e6*sign(u(3));
%     
%         end
        U(:,i)=u; 
        x_old = x_est;
        y_old = y;
    
        F_w(:,i) = model.WindForce(W_v(i),gamma(i), x(3), x(4), x(5), A_F, A_L, L);
        
    
        V_c(:,i)= model.CurrentVelocity(W_c(:,i),x);
        [x, NED_Position] = model.UpdateState(u, W_c(:,i), W_v(i), gamma(i), dt);
        x_est = A*x_est + B * u + K*(y - D*x_est);
        X(:,i)=x; 
        Y(:,i)=y_NED(:,i);

    end


end
Y(3,:) = Y(3,:)*180/pi;

time = linspace(0,dt*length(U), length(U));
plot_limit=6000;

sysIdFName = "sysIdData.mat";
save(sysIdFName,"U","y_vector");

figure(1);
subplot(411);
plot(time(1:plot_limit),y_vector(1,1:plot_limit), 'r-','LineWidth',1);xlabel('Time [s]');ylabel('Position in Surge [m]');title('Position in Surge');
hold on;
plot(time(1:plot_limit),sp_ship_vector(1,1:plot_limit), 'b-','LineWidth',1);legend('Surge Position', 'Set Point Surge'); grid;
hold off;
subplot(412);
plot(time(1:plot_limit),Y(1,1:plot_limit), 'r-','LineWidth',1);xlabel('Time [s]');ylabel('Position North of NED[N]');title('Position in North of NED');
hold on;
plot(time(1:plot_limit),sp(1,1:plot_limit), 'b-','LineWidth',1);legend('Surge Position', 'Set Point Surge'); grid;
hold off;
subplot(413);
plot(time(1:plot_limit),U(1,1:plot_limit),'g-','LineWidth',1);xlabel('Time [s]');ylabel('Input Signal Surge[N]');legend('Control Signal Surge');grid;title('Input Signal in Surge');
subplot(414);
plot(time(1:plot_limit),F_w(1,1:plot_limit),'c-', 'LineWidth',1);xlabel('Time [s]');ylabel('Wind Force in Surge direction [N]');grid;title('Wind Force in Surge');legend('Wind Force in Surge');

figure(2);
subplot(411);
plot(time(1:plot_limit),y_vector(2,1:plot_limit), 'r-','LineWidth',1);xlabel('Time [s]');ylabel('Position in Sway [m]');title('Position in Sway');title('Position in Sway');
hold on;
plot(time(1:plot_limit),sp_ship_vector(2,1:plot_limit), 'b-','LineWidth',1);legend('Sway Position', 'Set Point Sway'); grid;
hold off;
subplot(412);
plot(time(1:plot_limit),Y(2,1:plot_limit), 'r-','LineWidth',1);xlabel('Time [s]');ylabel('Position East of NED[N]');title('Position in Sway');title('Position in East of NED');
hold on;
plot(time(1:plot_limit),sp(2,1:plot_limit), 'b-','LineWidth',1);legend('Sway Position', 'Set Point Sway'); grid;
hold off;
subplot(413);
plot(time(1:plot_limit),U(2,1:plot_limit),'g-','LineWidth',1);xlabel('Time [s]');ylabel('Input Signal Sway[N]');legend('Control Signal Sway');grid;title('Input Signal in Sway');
subplot(414);
plot(time(1:plot_limit),F_w(2,1:plot_limit),'c-', 'LineWidth',1);xlabel('Time [s]');ylabel('Wind Force in Sway direction [N]');grid;title('Wind Force in Sway');legend('Wind Force in Sway');

figure(3);
subplot(411);
plot(time(1:plot_limit),y_vector(3,1:plot_limit), 'r-','LineWidth',1);xlabel('Time [s]');ylabel('Position in Yaw[Deg]');title('Position in Yaw');title('Position in Yaw');
hold on;
plot(time(1:plot_limit),sp_ship_vector(3,1:plot_limit), 'b-','LineWidth',1);legend('Yaw Position', 'Set Point Yaw'); grid;
hold off;
subplot(412);
plot(time(1:plot_limit),Y(3,1:plot_limit), 'r-','LineWidth',1);xlabel('Time [s]');ylabel('Position in Yaw[Deg]');title('Position in Yaw');title('Position in Yaw');
hold on;
plot(time(1:plot_limit),sp(3,1:plot_limit), 'b-','LineWidth',1);legend('Yaw Position', 'Set Point Yaw'); grid;
hold off;
subplot(413);
plot(time(1:plot_limit),U(3,1:plot_limit),'g-','LineWidth',1);xlabel('Time [s]');ylabel('Input Signal Yaw[Nm]');legend('Control Signal Yaw');grid;title('Input Signal in Yaw');
subplot(414);
plot(time(1:plot_limit),F_w(3,1:plot_limit),'c-', 'LineWidth',1);xlabel('Time [s]');ylabel('Wind Moment in Yaw [Nm]');grid;title('Wind Moment');legend('Wind Moment');