function [A, B, D] = linearize_model(u, d, m, dt)

Ac = [0 0 0 1 0 0;
      0 0 0 0 1 0;
      0 0 0 0 0 1;
      0 0 0 0 0 0;
      0 0 0 0 0 0;
      0 0 0 0 0 0;];
%The last three rows of Ac are zero because we are using the simplified
%model where d is approximated to zero as it is very small compared to the
%m values.

Bc = [0 0 0;
      0 0 0;
      0 0 0;
      (1/m(1)) 0 0;
      0 (1/m(2)) 0;
      0 0 (1/m(3))];
%Same here, the terms where there is a d divided by m are approximated to
%zero.

Dc = [1 0 0 0 0 0;
      0 1 0 0 0 0;
      0 0 1 0 0 0;];

sys = ss(Ac,Bc,Dc,0);
ds = c2d(sys,dt);
A = ds.a; B = ds.b; D = ds.c; 
end